"spdest.beta2theta" <-
function(beta)
{
## the input are the first (L-1) coefficients
  L=NROW(beta)+1
## betas sum to one (add the last nuisance one)
  if(sum(beta)>1) beta=0.999*beta/sum(beta)
  beta=rbind(as.matrix(beta),(1-sum(beta)))
## log(thetas) solve the equation matr*theta=0
  matr=matrix(rep(beta,L),L,L)-diag(rep(1,L))
  theta=(-1)*(ginv(matr)%*%matr-diag(rep(1,L)))%*%rep(1,L)
## just to be sure that it is positive
  theta=theta*sign(theta)
  theta=theta/sum(theta)
  return(theta)
}

