"spdest.cvr" <-
function(ttime,L,xd,nc,np,CL,PT)
{
  ord=order(ttime,decreasing=TRUE)
  df=diff(c(-1,-ttime[ord]))
  cs=cumsum(df)
  ## another possibility: cs=cumsum(df^2)???
  rnk=rank(1-ttime)
  tmp=matrix(rep(rnk,NROW(ord)),NROW(ord))
  tmp=pmin(tmp,(t(tmp)))
  mcs=matrix(cs[tmp],NROW(cs))
  cvr=(xd%*%t(xd))*mcs
  if(CL&&PT) {
    ## covariance between calls and puts
    cpc=(xd[1:nc,2:(L-1)]%*%t(xd[(nc+1):(nc+np),(L-1):2]))*mcs[1:nc,(nc+1):(nc+np)]
    cvr[1:nc,(nc+1):(nc+np)]=cpc
    cvr[(nc+1):(nc+np),1:nc]=t(cpc)
  }
  return(cvr)
}

