"spdest.xd" <-
function(price)
{
## which strike prices are in the dataset? 
  tmp=factor(price[,1])
  K=as.numeric(levels(tmp))
  L=nlevels(tmp)
  puts=as.logical(price[,3])
  np=sum(puts)
  n=NROW(price)
  nc=n-np
  CL=as.logical(nc)
  PT=as.logical(np)
  xc=NULL
  y=NULL
  if(CL) {
    xc=contr.treatment(L,base=L)[tmp[1:nc],]
    xc=t(apply(xc,1,cumsum)*(K[2:L]-K[1:(L-1)]))
    xc=t(apply(xc,1,cumsum))[,(L-1):1]
    y=c(y,price[1:nc,2])
  }
  xd=NULL
  xp=NULL
  if(PT) {
    xp=contr.treatment(L,base=1)[tmp[(nc+1):(n)],]
    xp=t((apply(xp[,(L-1):1],1,cumsum)[(L-1):1,])*(K[2:L]-K[1:(L-1)]))
    xp=t(apply(xp[,(L-1):1],1,cumsum)[(L-1):1,])
## the conditions on alpha <--> beta
## beta= cns + a2b * alfa
    a2b=rbind(rep(-1,L-1),cbind(rep(0,L-2),(diag(rep(1,L-2))[(L-2):1,])))
    cns=c(1,rep(0,L-2))
## yp=b_0 + xp (cns + a2b * alfa)
## correct the response variable by xp * cns (i.e. substract the 1-st column of xp)
    y=c(y,price[(nc+1):n,2]-xp[,1])
## correct the design matrix: xp * a2b
    xd=xp%*%a2b
  }
## the design matrix 
  xd=rbind(xc,xd)
## add the absolute term at the end of the design matrix  
  if (CL&&PT) {
    xd=cbind(xd,1-puts,puts)
  } else {
    xd=cbind(xd,rep(1,n))
  }
  return(list(y=y,xc=xc,xp=xp,xd=xd,L=L,K=K))
}

